//---------------------------------------------------------------------------
#ifndef App_CommonH
#define App_CommonH
//---------------------------------------------------------------------------
#include <Classes.hpp>
namespace Inifiles {class TMemIniFile;} using namespace Inifiles;
//---------------------------------------------------------------------------
namespace App_common {
//---------------------------------------------------------------------------
class EAppError : public Exception
{
public:
	__fastcall EAppError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TCommon
{
private:
protected:
public:
	static const AnsiString Title;
	static const AnsiString About;
	static const AnsiString HelpFile;
	static const AnsiString SettingsFile;
	static AnsiString __fastcall FormatInteger(int AValue);
	static AnsiString __fastcall FormatInteger(__int64 AValue);
};
//---------------------------------------------------------------------------
class TSettingsHandler : public TObject
{
private:
protected:
public:
	__fastcall TSettingsHandler();
	virtual __fastcall ~TSettingsHandler();
	virtual void __fastcall LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection);
};
//---------------------------------------------------------------------------
class TSettingsHandlers : public TObject
{
private:
	TStringList* FList;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	__property TStringList* List = {read=FList};
protected:
public:
	__fastcall TSettingsHandlers();
	virtual __fastcall ~TSettingsHandlers();
	virtual void __fastcall Add(TSettingsHandler* AHandler, const AnsiString& ASection);
	virtual void __fastcall Remove(TSettingsHandler* AHandler);
	virtual void __fastcall Clear();
	virtual void __fastcall LoadSettings();
	virtual void __fastcall SaveSettings();
};
//---------------------------------------------------------------------------
class TModel : public TSettingsHandler
{
private:
protected:
public:
	__fastcall TModel();
	virtual __fastcall ~TModel();
};
//---------------------------------------------------------------------------
class TView : public TSettingsHandler
{
private:
protected:
public:
	__fastcall TView();
	virtual __fastcall ~TView();
};
//---------------------------------------------------------------------------
class TCommands : public TSettingsHandler
{
private:
protected:
	virtual void __fastcall HandleFeatureUnavailable();
public:
	__fastcall TCommands();
	virtual __fastcall ~TCommands();
};
//---------------------------------------------------------------------------
} // End namespace App_common
using namespace App_common;
//---------------------------------------------------------------------------
#endif

