//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_Split.h"
#include "Moa_Files.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_split {
//---------------------------------------------------------------------------
__fastcall TSplitPathProducer::TSplitPathProducer() :
	TObject(),
	FDirectory(),
	FArchive(),
	FEntryPrefix(),
	FEntrySuffix(),
	FExtension()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TSplitPathProducer::~TSplitPathProducer()
{
	// Do nothing
}
//---------------------------------------------------------------------------
AnsiString __fastcall TSplitPathProducer::Produce(const AnsiString& ADiskName)
{
	AnsiString LDirectory = IncludeTrailingPathDelimiter(Directory);
	AnsiString LBaseName = ADiskName;
	LBaseName = TPathUtilities::Trim(LBaseName);
	LBaseName = TPathUtilities::ReplaceInvalidNameCharacters(LBaseName, '_');
	LBaseName = Archive + EntryPrefix + LBaseName + EntrySuffix;
	AnsiString LExtension = AnsiString('.') + Extension;
	int LMinIndex = 1;
	int LMaxIndex = 1000;
	for(int LIndex = LMinIndex; LIndex <= LMaxIndex; ++LIndex) {
		AnsiString LPath = LBaseName;
		if(LIndex > LMinIndex) {
			LPath += AnsiString().sprintf(" (%d)", LIndex);
		}
		LPath = LDirectory + LPath + LExtension;
		if(!TFileUtilities::Exists(LPath)) {
			return LPath;
		}
	}
	throw EAppError("The program could not produce a path.");
}
//---------------------------------------------------------------------------
} // End namespace App_split
//---------------------------------------------------------------------------

